/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
** 
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor. 
*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <qmessagebox.h>
#include <qstring.h>
#include <qlistbox.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qdir.h>    
#include "MainForm.h"
  
void Record_IncludeForm::init() 
{  
    pushButton8->hide();
    QString nameFilter = "*.h";
    QDir dir("/G_Studio/file", nameFilter, QDir::DirsFirst);
    dir.setMatchAllDirs(true);
    if(!dir.isReadable())//is not access
    {
	Include_list->insertItem ("There is not any Headerfile");
	return;
    }
    QStringList entries = dir.entryList();
    QStringList::ConstIterator it = entries.constBegin();
    QString temp;
    while(it != entries.constEnd())
    {
	if(*it == "." || *it == "..")
	{
	  
	}
	else
	{
	    Include_list->insertItem (*it);
	}
	++it;

    }
    
}


void Record_IncludeForm::record_button_clicked()
{
    bool user_header = false;
    QString filename = QFileDialog::getOpenFileName("/", "Header (*.h)",  this, "Record Header File", "Choose a HeaderFile" );
    if(filename.isEmpty())
    {
	QMessageBox::warning(this, "Not Selected", "It is not selected HeaderFile");
	return;
    }
    if(Include_list->findItem("__"+ Device_Filename( filename) , 1) != 0)
    {
	QMessageBox::critical(this, "HeaderFile Exsist", "This Header File exsist");
	return ;	
    }
    if( strncmp( filename.ascii(), "/usr/include/", 13 ) != 0)
    {
	Flitering_UserHeaderfile( filename );
	return ;
    }
    RecordFile = fopen("/G_Studio/file/__"+ Device_Filename( filename), "w");
    file.setName(filename);
    file.open(IO_ReadOnly);
 
    while(!file.atEnd())
    {
	file.readLine(Line, 10000);
	if(Line.contains("extern") >0 && Line.contains("(") > 0 && Line.contains("#define") == 0)
	    Extern_Fuction();
    }
    fclose(RecordFile);
    Include_list->clear();
    init();
    file.close();
    Rewrite_main_FunctionList();
}


void Record_IncludeForm::Extern_Fuction()
{
    int LineEnd_flag =0;
    int len = 0;
    int j = 0;
    char sentence[1000];
    char temp[1000];
    memset(&sentence, 0, sizeof(sentence));
    memset(&temp, 0, sizeof(temp));    
    strcpy(sentence, Line.ascii());
    for(int i = 0 ; i < strlen(sentence) ; i++)
    {
	if( strncmp("extern", sentence + i , 6) == 0 && j == 0 )
	    j = i +7;// For delete 'exterrn'
	
	if(LineEnd_flag >1)
	{
	    return;
	}
	
	if(sentence[i] == '(')
	{
	    LineEnd_flag++;
	}
	if(sentence[i] == ')')
	{
	    strncat(temp, sentence + len, i +1 - len);
	    fprintf(RecordFile, "%s\n", temp + j);
	    return;
	}
	if(i == strlen(sentence) -1 && LineEnd_flag == 1)
	{
    	    strncat(temp, sentence + len, i - len);
	    i =0;
	    len = 0;
	    file.readLine(Line, 10000); 
	    memset(&sentence, 0, sizeof(sentence));
	    strcpy(sentence, Line.ascii());
	    while(1)
	    {
		if(sentence[i] == ' ' || sentence[i] == '	')
		    i++;
		else
		{
		    len = i;
		    i = 0;
		    break;
		}
	    }
	}
    }
    
}


QString Record_IncludeForm::Device_Filename( QString filename )
{
    char temp[300];
    char str[300]; 
    char real[300]; 	
    sprintf(temp, filename);
    memset(&str, 0, sizeof(str)); 
    memset(&str, 0, sizeof(real)); 
    int len = strlen(temp);// Get filename Lenge //
    for(int i = len-1 ; i > -1 ; i--) // Loop : start-> End of filename , break -> meet first char "/"
    { 
	if(temp[i] == '/') 
	{ 
	    i++; 
	    strcpy(real, temp+i); 
	    strncat(str, temp, i); 
	    break; 
	} 
    }
    filename.sprintf("%s", real);//store Project Name
    return filename;//return Project Name
}


void Record_IncludeForm::aaaa()
{
    QString nameFilter = "*.h";
    QDir dir("/usr/include", nameFilter, QDir::DirsFirst);
    dir.setMatchAllDirs(true);
    if(!dir.isReadable())//is not access
    {
	return;
    }
    QStringList entries = dir.entryList();
    QStringList::ConstIterator it = entries.constBegin();
    QString temp;
    while(it != entries.constEnd())
    {
	if( (*it).endsWith(".h") == 0)
	{
	  
	}
	else
	{
	    RecordFile = fopen("/G_Studio/file/__"+ *it, "w");
	    file.setName("/usr/include/"+*it);
	    if(!file.open(IO_ReadOnly))
		return;
	    else
		QMessageBox::question(this, "open", *it);
	    
	    while(!file.atEnd())
	    {
		file.readLine(Line, 10000);
		
		if(Line.contains("extern") >0 && Line.contains("(") > 0 && Line.contains("#define") == 0)
		    Extern_Fuction();
	    }
	    fclose(RecordFile);
	    Include_list->clear();
	    init();
	    file.close();
	}
	++it;
    }
}


void Record_IncludeForm::include_list_clicked()
{
    Function_list->clear();
    char temp[10000];
    file.setName("/G_Studio/file/"+ Include_list->currentText());
    if(!file.open(IO_ReadOnly))
    {
	QMessageBox::critical(this, "Not Open", "Fail to open this HeaderFile");
	return;
    }

 
    while(!file.atEnd())
    {
	file.readLine(Line, 10000);
	memset(&temp, 0, sizeof(temp));
	strncpy(temp, Line.ascii(), Line.length() -1 );
	Function_list->insertItem(temp);
    }
    file.close();
}


void Record_IncludeForm::Record_MainForm_List(QString FileName)
{
    QString temp;
    char line[1000];
    char Function_name[100];
    int i;
    int flag = 0;
    memset(&line, 0, sizeof(line));
    memset(&Function_name, 0 , sizeof(Function_name));
    file.setName("/G_Studio/file/" +FileName);
    if(! file.open(IO_ReadOnly))
    {
//	QMessageBox::critical(this, "Fail to Record", "Fail to record on MainForm List");
	return;
    }

    while(!file.atEnd())
    {
	memset(&line, 0, sizeof(line));
	memset(&Function_name, 0, sizeof(Function_name));
	file.readLine(temp, 10000);
	strncpy(line, temp.ascii(), temp.length() -1);
	for( i =0 ; i < strlen(line) ; i++)
	{
	    if(flag == 0 && line[i] == ' ' && line[i+1] == '*')
	    {		
		flag = i +2;
	    }
	    else if(flag == 0 && line[i] == ' ' && line[i+1] != ' ')
	    {
		flag = i+1;		
	    }
	    else if(flag != 0 && line[i] == ' ')
	    {
		strncpy(Function_name, line + flag, i - flag);
		flag = 0;
		break;
	    }
	}
	mainform->List_Fun_name->insertItem(Function_name, 1);
	mainform->List_Function->insertItem(line, 1);
    }
    file.close();
}


void Record_IncludeForm::Set_MainForm_Pointer(MainForm *fp)
{
    mainform = fp;
}


bool Record_IncludeForm::Flitering_UserHeaderfile( QString filename )
{
    int FSA = 0;
    int count = 0;
    int token_index = 0;
    int Function_index = 0;
    char Line[10000];
    char Token[100];
    char Function[1000];
    bool comment_flag = false;
    bool break_flag = false;
    bool flag1 = false;
    bool flag2 = false;
    QString temp;
    memset(&Token, 0, sizeof( Token ));
    memset(&Function, 0, sizeof( Function ));
    RecordFile = fopen("/G_Studio/file/__"+ Device_Filename( filename), "w");
    file.setName(filename);
    file.open(IO_ReadOnly);
    
    while(!file.atEnd())
    {
	memset(&Line, 0, sizeof( Line ));
	file.readLine(Line, 10000);
	memset(&Token, 0, sizeof( Token ));
	token_index = 0;
	flag2 = false;	
	flag1 = false;
	for( int i = 0 ; i < strlen(Line); i++)
	{
	    if(( Line[i] == '(' || Line[i] == ')' || Line[i] == '{' || Line[i] == ';' )&& comment_flag == false)
	    {

		if( flag1 == false && flag2 == false)
		{
		    flag1 = true;
		    i--;
		}
		else if( flag1 == true && flag2 == false )
		{
		    memset(&Token, 0, sizeof( Token ));
		    Token[0] = Line[i];
		    if( Line[i] != ';' && Line[i] != '{' )
		    {
			Function[Function_index] = Line[i];
			Function_index ++;		    
		    }
		    flag1 = false;
		    flag2 = true;
		    token_index = 1;
		}

	    }
	    if( Line[i] == '/' && Line[i+1] == '/' && comment_flag == false )
	    {
		memset(&Token, 0, sizeof( Token ));
		memset(&Function, 0, sizeof( Function ));
		break;
	    }
	    else if( Line[i] == '/' && Line[i+1] == '*' && comment_flag == false)
	    {
		comment_flag = true;		
	    }
	    else if( Line[i] == '*' && Line[i+1] == '/' && comment_flag == true)
	    {
		i++;
		comment_flag = false;		
	    }
	    else if( Line[i] == '=' && comment_flag== false )
	    {
		memset(&Token, 0, sizeof( Token ));
		memset(&Function, 0, sizeof( Function ));
		FSA = 0;
		token_index = 0;
		Function_index = 0;
		count = 0;
		break_flag = false;
		break;
	    }
	    else if(Line[i] == '\n' || Line[i] == '\n'&& comment_flag== false)
	    {
	    }
	    else if(Line[i] == '#' && comment_flag== false)
	    {
		memset(&Token, 0, sizeof( Token ));
		memset(&Function, 0, sizeof( Function ));
		FSA = 0;
		token_index = 0;
		Function_index = 0;
		count = 0;
		break;
	    }
	    else if( (Line[i] == ' ' || Line[i] == '	' || flag1 == true || flag2 == true) && comment_flag== false)
	    {
		strcat( Function , " ");
		Function_index ++;		
		if( flag2 == true)
		    flag2 = false;
		switch( FSA )
		{
		case 0:
		    if( strcmp(Token , "(") == 0 || strcmp(Token , ")") == 0 || strcmp(Token , ";") == 0||strcmp(Token , "{") == 0)
			break_flag = true;
		    else if( strlen(Token) == 0 || strcmp( Token, " ") == 0 || strcmp( Token, "	") == 0)
			;
		    else
			FSA = 1;
		    break;
		case 1:
		    if( strcmp(Token , "(") == 0 || strcmp(Token , ")") == 0 || strcmp(Token , ";") == 0||strcmp(Token , "{") == 0)
			break_flag = true;
		    else if( strlen(Token) == 0 || strcmp( Token, " ") == 0 || strcmp( Token, "	") == 0)
			;
		    else
			FSA = 2;
		    break;
		case 2:
		    if( strcmp( Token, " ") == 0 || strcmp( Token, "	") == 0|| strlen(Token) == 0)
		    {

		    }
		    else if( strcmp(Token , ")") == 0 || strcmp(Token , ";") == 0||strcmp(Token , "{") == 0)
		    {
			break_flag = true;			
		    }
		    else if( strcmp(Token , "(") == 0)
		    {
			count++;
			FSA = 3;
		    }
		    break;
		case 3:
		    if( strcmp( Token, " ") == 0 || strcmp( Token, "	") == 0|| strlen(Token) == 0)
		    {
		    }
		    if( strcmp(Token , "(") == 0)
		    {
			count++;
		    }
		    else if( strcmp( Token, ")") == 0 )
		    {
			count--;
			if( count == 0)
			    FSA = 4;
		    }
		    break;
		case 4:
		    if( strcmp( Token, " ") == 0 || strcmp( Token, "	") == 0 || strlen(Token) == 0)
		    {
		    }
		    else if( strcmp(Token, "{") == 0)
		    {
			fprintf(RecordFile, "%s\n", Function);
			break_flag = true;
		    }
		    else if( strcmp(Token, ";") == 0 )
		    {
			fprintf(RecordFile, "%s\n", Function);
			break_flag = true;
		    }
		    else
		    {
			break_flag = true;			
		    }
		    break;		    
		}
		if( break_flag == true)
		{
    			memset(&Token, 0, sizeof( Token ));
			memset(&Function, 0, sizeof( Function ));
			FSA = 0;
			token_index = 0;
			Function_index = 0;
			count = 0;
			break_flag = false;
			break;
		}
		memset(&Token, 0, sizeof( Token ));
		token_index = 0;
	    }
	    else if(comment_flag == false)
	    {

		Token[token_index] = Line[i];
		Function[Function_index] = Line[i];
		token_index ++;
		Function_index ++;
	    }
	}
    }
    fclose(RecordFile);
    Include_list->clear();
    init();
    file.close();
    Rewrite_main_FunctionList();
}


void Record_IncludeForm::Cmd_Del_Func_clicked()
{
    system("rm /G_Studio/file/"+ Include_list->currentText());
    Include_list->clear();
    init();
    file.close();
    Rewrite_main_FunctionList();
}


void Record_IncludeForm::Rewrite_main_FunctionList()
{
    mainform->List_Fun_name->clear();
    mainform->List_Function->clear();
    QString nameFilter = "*.h";
    QDir dir("/G_Studio/file", nameFilter, QDir::DirsFirst);
    int i =0;
    dir.setMatchAllDirs(true);
    if(!dir.isReadable())//is not access
    {
	QMessageBox::question(this,"Read Error", "Read Error");
	return;
    }
    QStringList entries = dir.entryList();
    QStringList::ConstIterator it = entries.constBegin();
    QString temp;
    while(it != entries.constEnd())
    {
	if(*it == "." || *it == "..")
	{
	  
	}
	else
	{
	    Set_main_function_list(*it);
	}
	++it;

    }
}


void Record_IncludeForm::Set_main_function_list( QString FileName )
{
   QFile file;
    QString temp;
    char line[1000];
    char Function_name[100];
    int i;
    int flag = 0;
    memset(&line, 0, sizeof(line));
    memset(&Function_name, 0 , sizeof(Function_name));
    file.setName("/G_Studio/file/" +FileName);
    if(! file.open(IO_ReadOnly))
	return;
    while(!file.atEnd())
    {
	memset(&line, 0, sizeof(line));
	memset(&Function_name, 0, sizeof(Function_name));
	file.readLine(temp, 10000);
	strncpy(line, temp.ascii(), temp.length() -1);

	for( i =0 ; i < strlen(line) ; i++)
	{
	    if(flag == 0 && line[i] == ' ' && line[i+1] == '*')
	    {		
		flag = i +2;
	    }
	    else if(flag == 0 && line[i] == ' ' && line[i+1] != ' ')
	    {
		flag = i+1;		
	    }
	    else if(flag != 0 && line[i] == ' ')
	    {
		strncpy(Function_name, line + flag, i - flag);
		flag = 0;
		break;
	    }
	}
	mainform->List_Fun_name->insertItem(Function_name, 1);
	mainform->List_Function->insertItem(line, 1);
    }
 
    file.close();
}


void Record_IncludeForm::Filtering_Function_Definition()
{

}
