 /****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
** 
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and  
** destructor.
******************************************************************************/
#include "Project_Setting.h"
#include <qlistbox.h>
#include <qmessagebox.h>
#include <qstring.h>
#include <qsize.h> 
#include <qfile.h>
#include <qtextstream.h>
#include <qeuckrcodec.h>
 
#define kor(str) QString::fromLocal8Bit(str) 
void Option_Form::Set_Pro_Set_Pointer( Project_Setting *fp )
{
    pro_set = fp;
} 


void Option_Form::Add_Option_List( QString list_name ) 
{
    File_Option->insertItem(list_name, -1); 
}


void Option_Form::cmd_OK_button_clicked()
{
    int i;
    if(Option_collection->isHidden())
    {
	pro_set->Library_List_Clear_currentPage();
	pro_set->Rewrite_Library("ADD Libaray");
	for(i = 0 ; i < File_Option->count() ; i++)
	    pro_set->Rewrite_Library(File_Option->text(i));
	pro_set->File_Tab_chaged();
	this->close();
    }
    else
    {
	pro_set->Option_List_Clear_currentPage();
	pro_set->Rewrite_Option("ADD Option");
	for(i = 0 ; i < File_Option->count() ; i++)
	    pro_set->Rewrite_Option(File_Option->text(i));	
	pro_set->File_Tab_chaged();	
	this->close();
    }
}


void Option_Form::cmd_Add_button()
{

    if(Option_collection->isHidden())
    {
	if( Library_collection->currentText().isEmpty())
	{
	    QMessageBox::critical(this, "Option ADD Error", "There is not seleted Option!!");
	    return ;
	}
	if(File_Option->findItem(Library_collection->currentText(), 1) != 0)
	    QMessageBox::critical(this, "Option ADD Error", "This Option is Exist!!\nSo Can not Add it!!");
	else
	    File_Option->insertItem(Library_collection->currentText(), -1);
    }
    else
    {
	if( Option_collection->currentText().isEmpty())
	{
	    QMessageBox::critical(this, "Option ADD Error", "There is not seleted Option!!");
	    return ;
	}
	if(File_Option->findItem(Option_collection->currentText(), 1) != 0)
	    QMessageBox::critical(this, "Library ADD Error", "This Library is Exist!!\nSo Can not Add it!!");
	else
	    File_Option->insertItem(Option_collection->currentText(), -1);	
    }    
  
}


void Option_Form::cmd_Del_button()
{
	File_Option->removeItem(File_Option->currentItem());
}


void Option_Form::E_Write_Option_Lost_Focuse()
{
    E_Write_Option->setText("You can write Option & Library directly!!");
}


void Option_Form::cmd_write_option_clicked()
{
    if(Option_collection->isHidden())
    {
	if(File_Option->findItem(E_Write_Option->text(), 1) != 0)
	    QMessageBox::critical(this, "Option ADD Error", "This Option is Exist!!\nSo Can not Add it!!");
	else
	    File_Option->insertItem(E_Write_Option->text(), -1);
    }
    else
    {
	if(File_Option->findItem(E_Write_Option->text(), 1) != 0)
	    QMessageBox::critical(this, "Library ADD Error", "This Library is Exist!!\nSo Can not Add it!!");
	else
	    File_Option->insertItem(E_Write_Option->text(), -1);	
    }
}


void Option_Form::cmd_up_pos_clicked()
{
    QString text;
    int index;
    index =  File_Option->currentItem();
    if( index == 0 )
	return;
    text = File_Option->currentText();
    File_Option->removeItem(index);
    File_Option->insertItem( text , index -1);
    File_Option->setSelected( index -1 , true);
}


void Option_Form::cmd_down_pos_clicked()
{
    QString text;
    int index;
    index = File_Option->currentItem();
    if( index == File_Option->count() - 1 )
	return;
    text = File_Option->currentText();
    File_Option->removeItem(index);
    File_Option->insertItem( text , index +1);
    File_Option->setSelected( index +1 , true);    
}


void Option_Form::Collection_double_clicked()
{
    if(Option_collection->isHidden())
    {
	E_Write_Option->setText( Library_collection->currentText() );
    }
    else
    {
	E_Write_Option->setText( Option_collection->currentText() );
    }

}


void Option_Form::init()
{
    option_info->hide();
}


void Option_Form::Option_list_Clicked()
{
    if( option_info->isHidden() == false)
    {
    }
    else
    {
	QSize form_size( 830, 500 );
	QSize text_size( 270, 500 );
	option_info->show();
	option_info->setMinimumSize(text_size);
	option_info->setMinimumSize(text_size);
	this->setMaximumSize( form_size );
	this->setMinimumSize( form_size );
    }
    QFile file;
    QString str; 
    QTextStream stream( &file );
    file.setName("/G_Studio/Option_INFO/__"+ Option_collection->currentText()+ ".txt");
    if(!file.open( IO_ReadOnly ))
    {
	option_info->setText("NO DATA");
    }
    else
    {
	str = stream.read();
	option_info->setText( kor( str.utf8()));
    }
 /*   while( !stream.atEnd())
    {
	str = stream.readLine();
	option_info->insert(str+"\n");
    }*/
}
